# For developers

## Setting up `pre-commit`

[`pre-commit`](https://pre-commit.com/) is a framework that helps to manage and maintain pre-commit hooks to ensure that your code adheres to a consistent style, prevents errors, and adheres to other quality assurance checks.

1. **Install `pre-commit`:**
   To ensure smooth development, install `pre-commit` using pip by running the following command:

   ```bash
   pip install pre-commit
   ```

   For more information and installation options, visit the [`pre-commit`](https://pre-commit.com/) website.

2. **Navigate to the project directory:**
    Change into the project directory, i.e., `julia-seminar` by running:

    ```bash
    cd julia-seminar
    ```

3. **Install hooks:**
    Install the git hooks by executing:

    ```bash
    pre-commit install
    ```

    This command installs the pre-commit script alongside existing git hooks.

Once the pre-commit hook is installed, it will automatically check your code for any issues before each commit. If the checks do not pass, you will be prompted to fix them before proceeding.

## Localizing the notebooks

1. Make sure the bilingual version of the notebook is in the folder `src/`. This is for clarity reasons.

2. Run `./localize.py bilingual_notebook.ipynb`. The script will ask for your help whenever it is unclear.
You should help it to set the language of the cell to one among `en`, `de` and `eq`.
The kind `eq` is for everything that is not a spoken language (figures, schemes, equations and similar).

3. You will get two versions in the `src/` folder. Move them to the root directory, add them to git and commit.
